--- misc/e2freefrag.c.orig	2013-07-28 20:09:52.000000000 +0200
+++ misc/e2freefrag.c	2013-07-28 20:10:05.000000000 +0200
@@ -172,10 +172,16 @@
 
 	/* Display chunk information in KB */
 	if (info->real_free_chunks) {
-		info->min = (info->min * fs->blocksize) >> 10;
-		info->max = (info->max * fs->blocksize) >> 10;
+	    	unsigned long scaled_blocksize = fs->blocksize;
+		int shift = 10;
+		if (fs->blocksize >= (1 << 10)) {
+		    	shift = 0;
+			scaled_blocksize = fs->blocksize >> 10;
+		}
+		info->min = (info->min * scaled_blocksize) >> shift;
+		info->max = (info->max * scaled_blocksize) >> shift;
 		info->avg = (info->avg / info->real_free_chunks *
-			     fs->blocksize) >> 10;
+			     scaled_blocksize) >> shift;
 	} else {
 		info->min = 0;
 	}
